summaryrefslogtreecommitdiffstats
path: root/tools/regression/tmpfs/t_create
diff options
context:
space:
mode:
Diffstat (limited to 'tools/regression/tmpfs/t_create')
-rw-r--r--tools/regression/tmpfs/t_create98
1 files changed, 98 insertions, 0 deletions
diff --git a/tools/regression/tmpfs/t_create b/tools/regression/tmpfs/t_create
new file mode 100644
index 0000000..39ea4f4
--- /dev/null
+++ b/tools/regression/tmpfs/t_create
@@ -0,0 +1,98 @@
+#!/bin/sh
+#
+# $NetBSD: t_create,v 1.5 2006/11/09 16:20:06 jmmv Exp $
+#
+# Copyright (c) 2005, 2006 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Julio M. Merino Vidal, developed as part of Google's Summer of Code
+# 2005 program.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+# 3. All advertising materials mentioning features or use of this software
+# must display the following acknowledgement:
+# This product includes software developed by the NetBSD
+# Foundation, Inc. and its contributors.
+# 4. Neither the name of The NetBSD Foundation nor the names of its
+# contributors may be used to endorse or promote products derived
+# from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+#
+# Verifies that the create operation works.
+#
+
+test_run() {
+ test_mount
+
+ test_name "Files can be created"
+ umask 022 || die
+ test -f a && die
+ touch a || die
+ test -f a || die
+ test_name "New files get proper attributes"
+ eval $(stat -s . | sed -e 's|st_|dst_|g')
+ eval $(stat -s a)
+ test ${st_flags} -eq 0 || die
+ test ${st_size} -eq 0 || die
+ test ${st_uid} -eq $(id -u) || die
+ test ${st_gid} -eq ${dst_gid} || die
+ test ${st_mode} = 0100644 || die
+
+ if [ -n "${Unprived_User}" ]; then
+ test_name "New files by users get proper attributes"
+
+ mkdir b c || die
+
+ chown ${Unprived_User}:0 b || die
+ eval $(stat -s b)
+ [ ${st_uid} -eq $(id -u ${Unprived_User}) ] || die
+ [ ${st_gid} -eq 0 ] || die
+
+ chown ${Unprived_User}:100 c || die
+ eval $(stat -s c)
+ [ ${st_uid} -eq $(id -u ${Unprived_User}) ] || die
+ [ ${st_gid} -eq 100 ] || die
+
+ su ${Unprived_User} -c 'touch b/a'
+ eval $(stat -s b/a)
+ [ ${st_uid} -eq $(id -u ${Unprived_User}) ] || die
+ [ ${st_gid} -eq 0 ] || die
+
+ su ${Unprived_User} -c 'touch c/a'
+ eval $(stat -s c/a)
+ [ ${st_uid} -eq $(id -u ${Unprived_User}) ] || die
+ [ ${st_gid} -eq 100 ] || die
+ fi
+
+ mkdir dir || die
+ echo 'touch dir/a' | kqueue_monitor 1 dir || die
+ test_name "Creating a file raises NOTE_WRITE on the parent directory"
+ kqueue_check dir NOTE_WRITE || die
+
+ test_unmount
+}
+
+. ${SUBRDIR}/h_funcs.subr
OpenPOWER on IntegriCloud